#pragma GCC optimize ("O2")
#include <bits/stdc++.h>
#define inline inline __attribute__((always_inline))
using namespace std;

typedef long long LL;
const int N=1e5+5;
int a[N],w[N],n,Q,bs,bn,br[N];
pair<int,int> b[N];
LL pre[N];

namespace BIT {
	LL t[N];
	inline int lowbit(int k) {return k&-k;}
	inline void modify(int p,LL val) {
		for(;p<=n;p+=lowbit(p)) t[p]+=val;
	}
	inline LL query(int p) {
		LL ret=0;
		for(;p;p-=lowbit(p)) ret+=t[p];
		return ret;
	}
	inline void clear() {memset(t,0,sizeof(t));}
}

const unsigned M=4294967295u;
inline unsigned xnor(LL a,LL b) {
	a&=M,b&=M;
	return (a&b)|(~(a|b));
}

inline void rebuild(int k) {
	for(int i=br[k];i<br[k+1];++i) b[i]=make_pair(w[i],i);
	sort(b+br[k],b+br[k+1]);
	pre[br[k]]=a[b[br[k]].second]*1ll*w[b[br[k]].second];
	for(int i=br[k]+1;i<br[k+1];++i) pre[i]=pre[i-1]+a[b[i].second]*1ll*w[b[i].second];
}

int main() {
	freopen("1.in","r",stdin);
	freopen("1.ans","w",stdout);
	
	scanf("%d%d",&n,&Q);
	bs=sqrt(n),bn=(n+bs-1)/bs;
	br[1]=1,br[bn+1]=n+1;
	for(int i=2;i<=bn;++i) br[i]=br[i-1]+bs;
	for(int i=1;i<=n;++i) {
		scanf("%d",&a[i]);
		BIT::modify(i,a[i]);
	}
	for(int i=1;i<=n;++i) scanf("%d",&w[i]);
	for(int i=1;i<=bn;++i) rebuild(i);
	for(int i=1,op,x,y,z;i<=Q;++i) {
		scanf("%d%d%d",&op,&x,&y);
		switch(op) {
			case 1:{
				scanf("%d",&z);
				LL ans=0,Ans=BIT::query(y)-BIT::query(x-1);
				int s=(x+bs-1)/bs,t=(y+bs-1)/bs;
				if(s!=t) {
					for(int i=s+1;i<t;++i) {
						int t1=lower_bound(b+br[i],b+br[i+1],make_pair(z+1,0))-b-1;
						ans+=(t1>=br[i] ? pre[t1] : 0);
					}
					for(int i=x;i<br[s+1];++i) if(w[i]<=z) ans+=a[i]*1ll*w[i];
					for(int i=br[t];i<=y;++i) if(w[i]<=z) ans+=a[i]*1ll*w[i];
				}
				else {
					for(int i=x;i<=y;++i) if(w[i]<=z) ans+=a[i]*1ll*w[i];
				}
				//printf("%lld %lld %u\n",ans,Ans,xnor(ans,Ans));
				printf("%u\n",xnor(ans,Ans));
				break;
			}
			case 2:{
				BIT::modify(x,-a[x]);
				a[x]=y;
				rebuild((x+bs-1)/bs);
				BIT::modify(x,a[x]);
				break;
			}
			case 3:{
				w[x]=y;
				rebuild((x+bs-1)/bs);
				break;
			}
		}
	}
	
	return 0;
}

