#pragma GCC optimize ("O2")
#include <bits/stdc++.h>
#define inline inline __attribute__((always_inline))
using namespace std;

typedef long long LL;
const int N=1e5+5;
int a[N],w[N],n,Q,qn,an;
LL ans[N],Ans[N];

namespace BIT {
	LL t[N];
	inline int lowbit(int k) {return k&-k;}
	inline void modify(int p,LL val) {
		for(;p<=n;p+=lowbit(p)) t[p]+=val;
	}
	inline LL query(int p) {
		LL ret=0;
		for(;p;p-=lowbit(p)) ret+=t[p];
		return ret;
	}
	inline void clear() {memset(t,0,sizeof(t));}
}

struct qt {
	int tp,id,l,r,w;
	LL val;
	inline qt(int TP=0,int ID=0,int L=0,int R=0,int W=0,LL VAL=0) {
		tp=TP,id=ID,l=L,r=R,w=W,val=VAL;
	}
	//enum tp 1 -> modify (in which r is not used) 2 -> query (in which val is not used)
}q[N<<2],le[N<<1],ri[N<<1];

void divide(int h,int t,int l,int r) {
	if(h>t) return;
	if(l==r) {
		for(int i=h;i<=t;++i) {
			if(q[i].tp==1) BIT::modify(q[i].l,q[i].val);
			else ans[q[i].id]=(q[i].val+=BIT::query(q[i].r)-BIT::query(q[i].l-1));
		}
		for(int i=h;i<=t;++i) if(q[i].tp==1) BIT::modify(q[i].l,-q[i].val);
		return;
	}
	
	int mid=(l+r)>>1;
	for(int i=h;i<=t;++i) {
		if(q[i].tp==1&&q[i].w<=mid) BIT::modify(q[i].l,q[i].val);
		else if(q[i].tp==2&&q[i].w>mid) q[i].val+=BIT::query(q[i].r)-BIT::query(q[i].l-1);
	}
	for(int i=h;i<=t;++i) if(q[i].tp==1&&q[i].w<=mid) BIT::modify(q[i].l,-q[i].val);
	
	int pa=0,pb=0;
	for(int i=h;i<=t;++i) {
		if(q[i].w<=mid) le[pa++]=q[i];
		else ri[pb++]=q[i];
	}
	for(int i=0;i<pa;++i) q[h+i]=le[i];
	for(int i=0;i<pb;++i) q[h+pa+i]=ri[i];
	divide(h,h+pa-1,l,mid); divide(h+pa,t,mid+1,r);
}

const unsigned M=4294967295u;
inline unsigned xnor(LL a,LL b) {return ~((a&M)^(b&M));}

int main() {
	freopen("1.in","r",stdin);
	freopen("1.out","w",stdout);
	
	scanf("%d%d",&n,&Q);
	for(int i=1;i<=n;++i) {
		scanf("%d",&a[i]);
		BIT::modify(i,a[i]);
	}
	for(int i=1;i<=n;++i) {
		scanf("%d",&w[i]);
		q[++qn]=qt(1,0,i,0,w[i],a[i]*1ll*w[i]);
	}
	for(int i=1,op,x,y,z;i<=Q;++i) {
		scanf("%d%d%d",&op,&x,&y);
		switch(op) {
			case 1:{
				scanf("%d",&z);
				q[++qn]=qt(2,++an,x,y,z,0);
				Ans[an]=BIT::query(y)-BIT::query(x-1);
				break;
			}
			case 2:{
				q[++qn]=qt(1,0,x,0,w[x],-a[x]*1ll*w[x]);
				BIT::modify(x,-a[x]);
				a[x]=y;
				q[++qn]=qt(1,0,x,0,w[x],a[x]*1ll*w[x]);
				BIT::modify(x,a[x]);
				break;
			}
			case 3:{
				q[++qn]=qt(1,0,x,0,w[x],-a[x]*1ll*w[x]);
				w[x]=y;
				q[++qn]=qt(1,0,x,0,w[x],a[x]*1ll*w[x]);
				break;
			}
		}
	}
	BIT::clear();
	divide(1,qn,0,N-5);
	for(int i=1;i<=an;++i) printf("%u\n",xnor(ans[i],Ans[i]));
	//printf("%lld %lld %u\n",ans[i],Ans[i],xnor(ans[i],Ans[i]));
	
	return 0;
}

